#import "AppController.h"
#import "WindowController.h"
#import "PreferencesController.h"
#import "StockDataSource.h"
#import "MLHTTPConnection.h"
#import "MLHTTPRequest.h"

@implementation AppController

// actions
- (IBAction) aboutPanel:(id)sender
{
    [NSApp orderFrontStandardAboutPanel:sender];
}

- (IBAction) showPreferencesPanel:(id)sender
{
    if (prefController == nil)
    {
        if ([NSBundle loadNibNamed:@"Preferences" owner:self] == NO)
        {
            [NSException raise:NSGenericException format:@"Unable to load Preferences.nib"];
        }
    }
    [prefController showPanel];
}

- (void) reloadSymbols:(NSNotification *)aNotification
{
    [winController reloadSymbols];
}
- (void) applicationWillFinishLaunching:(NSNotification *)aNotification
{

    // enable proxy support
    [MLHTTPConnection setupPosing];
    [MLHTTPRequest setupPosing];
    
    [StockDataSource loadDataSourceBundles];
}

- (void) applicationDidFinishLaunching:(NSNotification *)aNotification
{
    if ([NSBundle loadNibNamed:@"MainWindow" owner:self] == NO)
    {
        [NSException raise:NSGenericException format:@"Unable to load MainWindow.nib"];
    }
    [[NSNotificationCenter defaultCenter] addObserver:self
                                             selector:@selector(reloadSymbols:)
                                                 name:SymbolListUpdatedNotification
                                               object:nil];
    // load symbol list
    [self reloadSymbols:nil];
}
@end
