/* NSNumber+FractionExtensions.m created by mlaster on Sat 10-Jul-1999 */

#import "NSNumber+FractionExtensions.h"

@implementation NSNumber(FractionExtensions)

- (unsigned) greatestCommonFactorOf:(unsigned) x and:(unsigned)y
{
    unsigned i=0;
    unsigned max=MIN(x,y);
    unsigned gcf=1;

    for(i=max;i>1;i--)
    {
        if ((x % i) == 0 && (y % i) == 0)
        {
            gcf = i;
            break;
        }
    }
    return gcf;
}

- (NSAttributedString *) fractionalRepresentation
{
    NSMutableAttributedString *attrString = nil;
    NSScanner *aScanner = nil;
    NSString *workString = nil;
    unsigned whole = 0;
    unsigned numerator = 0;
    unsigned denominator = 0;
    unsigned gcf = 0;
    unsigned int i=0;
    aScanner = [[NSScanner alloc] initWithString:[self description]];
    [aScanner scanUpToString:@"." intoString:&workString];
    whole = [workString intValue];
    workString = nil;
    [aScanner setCharactersToBeSkipped:[NSCharacterSet punctuationCharacterSet]];
    [aScanner scanUpToString:@" " intoString:&workString];
    numerator = [workString intValue];
    if (numerator != 0)
    {
        denominator=1;
        for (i=0;i<[workString length];i++)
        {
            denominator=denominator*10;
        }
    }
    gcf = [self greatestCommonFactorOf:numerator and:denominator];
    numerator = numerator / gcf;
    denominator = denominator / gcf;

    attrString = [[NSMutableAttributedString alloc] initWithString:@""];
    if (whole != 0)
    {
        [[attrString mutableString] appendString:[NSString stringWithFormat:@"%u", whole]];
    }
    [attrString unscriptRange:NSMakeRange(0,[attrString length])];
    if (numerator != 0 && denominator != 0)
    {
        workString = [NSString stringWithFormat:@"%u", numerator];
        [[attrString mutableString] appendString:workString];
        [attrString superscriptRange:NSMakeRange([attrString length]-[workString length],[workString length])];
        [[attrString mutableString] appendString:@"/"];
        [attrString unscriptRange:NSMakeRange([attrString length]-1,1)];
        workString = [NSString stringWithFormat:@"%u", denominator];
        [[attrString mutableString] appendString:workString];
        [attrString subscriptRange:NSMakeRange([attrString length]-[workString length],[workString length])];
        // trailing space is required so we have something to attach the unscriptRange to
        [[attrString mutableString] appendString:@" "];
        [attrString unscriptRange:NSMakeRange([attrString length]-1,1)];
    }
    
    return [attrString autorelease];
}

- (NSAttributedString *) signedFractionalRepresentation
{
    NSMutableAttributedString *workString = nil;
    NSAttributedString *returnValue = nil;
    
    workString = [[self fractionalRepresentation] mutableCopy];
    if ([self floatValue] >= 0)
    {
        workString = [[NSMutableAttributedString alloc] initWithString:
            [NSString stringWithFormat:@"+"]];
    }
    else
    {
        workString = [[NSMutableAttributedString alloc] initWithString:
            [NSString stringWithFormat:@"-"]];
    }
    [workString appendAttributedString:[self fractionalRepresentation]];
    returnValue = [[workString copy] autorelease];
    [workString release];
    return returnValue;
}
@end
