/* StockDataSource.h created by mlaster on Thu 15-Jul-1999 */

#import <Foundation/Foundation.h>
#define StockDataUpdatedNotification @"StockDataUpdatedNotification"
/*
 Stock dictionary keys
 Symbol -- Stock symbol
 Price	-- Price (NSNumber)
 Volume -- Volume (NSNumber)
 LastUpdated -- Time this stock's price was last updated (NSDate)
 Open	-- Opening price (NSNumber)
 */
@interface StockDataSource : NSObject
{
    @private
    NSMutableDictionary *statDictionary;
    NSDictionary *colorCodes;
}

+ (StockDataSource *) dataSource;

+ (void) loadDataSourceBundles;
+ (void) registerDataSource:(NSString *)className;

// call [super update] only when you have new data available
- (void) update;

- (void) addSymbol:(NSMutableDictionary *)aSymbol;
- (void) removeSymbol:(NSString *)aSymbol;
- (void) removeAllSymbols;

- (NSMutableDictionary *) statDictionary;
- (void) setStatDictionary:(NSMutableDictionary *)newDictionary;

- (NSAttributedString *) attributedString;
- (NSAttributedString *) attributedStringForStockDictionary:(NSDictionary *)aDictionary;

- (void) reloadSymbols;


@end
